var tkprf = new Array();
tkprf["extensions.adhiyan.englishshortcut"] = "Alt+1";
tkprf["extensions.adhiyan.tsciishortcut"] = "Alt+2";
tkprf["extensions.adhiyan.tuneshortcut"] = "Alt+3";
tkprf["extensions.adhiyan.ascshortcut"] = "Alt+4";

function adhiyan_unloadAlert()
{
	if(tuneshortcut.keyData.modified || tsciishortcut.keyData.modified ||
		englishshortcut.keyData.modified || ascshortcut.keyData.modified )
		alert('Please restart '+navigator.appCodeName+' for changes to take effect.')
}

function adhiyan_setAccessKeys()
{
	var tkPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(
					Components.interfaces.nsIPrefService).getBranch("extensions.adhiyan.");
	adhiyan_setAccKey("english",tkPrefs);
	adhiyan_setAccKey("tune",tkPrefs);
	adhiyan_setAccKey("tscii",tkPrefs);
	adhiyan_setAccKey("asc",tkPrefs);
}

function adhiyan_setAccKey(kbrd,tkPrefs)
{
	if(tkPrefs.prefHasUserValue(kbrd+"shortcut"))
	{
		var ukey = document.getElementById(kbrd+"key");
		var keypref = adhiyan_parseShortcut(tkPrefs.getCharPref(kbrd+"shortcut"));
		var keycode = keypref.keyCode;
		var key = keypref.key;
		var modifiers = [];
		if(keypref.altKey) modifiers.push("alt");
		if(keypref.ctrlKey) modifiers.push("control");
		if(keypref.metaKey) modifiers.push("meta");
		if(keypref.shiftKey) modifiers.push("shift");
		modifiers = modifiers.join(" ");
		ukey.removeAttribute('key');
		ukey.removeAttribute('keycode');
		ukey.removeAttribute('modifiers');
		if(key != '') ukey.setAttribute('key', key);
		if(keycode != '') ukey.setAttribute('keycode', keycode);
		ukey.setAttribute('modifiers', modifiers);
	}
}

function adhiyan_setShortcut(aNode)
{
		window.openDialog(
			'chrome://adhiyan/content/keyDetecter.xul',
			'_blank',
			'chrome,modal,resizable=no,titlebar=no,centerscreen',
			aNode.keyData,
			document.getElementById('dialogMessage').getAttribute('dialogMessage'),
			document.getElementById('dialogMessage').getAttribute('dialogButton')
		);
		if (aNode.keyData.modified) {
			aNode.value = aNode.keyData.string;
			var event = document.createEvent('UIEvents');
			event.initUIEvent('input', true, false, window, 0);
			aNode.dispatchEvent(event);
		}
}
function adhiyan_clearShortcut(aNode)
{
	aNode.value = tkprf["extensions.adhiyan."+aNode.id];
	aNode.keyData = adhiyan_parseShortcut(aNode.value);
	aNode.keyData.modified = true;

	var event = document.createEvent('UIEvents');
	event.initUIEvent('input', true, false, window, 0);
	aNode.dispatchEvent(event);
}

function adhiyan_parseShortcut(aShortcut)
{
	var keys = aShortcut.split('+');
	var keyCode = keys[keys.length-1].replace(/ /g, '_').toUpperCase();

	var key = keyCode;
	keyCode = (keyCode.length == 1 ) ? '' : 'VK_'+keyCode ;
	key = (keyCode != '') ? '' : key;
	return {
		key      : key,
		charCode : (key ? key.charCodeAt(0) : '' ),
		keyCode  : keyCode,
		altKey   : /alt/i.test(aShortcut),
		ctrlKey  : /ctrl|control/i.test(aShortcut),
		metaKey  : /meta/i.test(aShortcut),
		shiftKey : /shift/i.test(aShortcut),
		string   : aShortcut,
		modified : false
	};
}

var tuneshortcut,tsciishortcut,englishshortcut,ascshortcut;

function adhiyan_setHotKeyVals()
{
	ascshortcut = document.getElementById('ascshortcut');
	ascshortcut.keyData = adhiyan_parseShortcut(ascshortcut.value);
	tuneshortcut = document.getElementById('tuneshortcut');
	tuneshortcut.keyData = adhiyan_parseShortcut(tuneshortcut.value);
	tsciishortcut = document.getElementById('tsciishortcut');
	tsciishortcut.keyData = adhiyan_parseShortcut(tsciishortcut.value);
	englishshortcut = document.getElementById('englishshortcut');
	englishshortcut.keyData = adhiyan_parseShortcut(englishshortcut.value);
}
